import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react'
import styles from './index.module.scss'
import { Button, DatePicker, Input, Select } from 'antd'
import { useDispatch, useSelector } from 'react-redux'
import { E3_APIdel, E3_APIgetList } from '@/store/action/E3actuality'
import { MessageFu } from '@/utils/message'
import history, { btnFlagFu } from '@/utils/history'
import { FourTableType } from '@/pages/B_enterTibet/B1collect/type'
import MyPopconfirm from '@/components/MyPopconfirm'
import store, { RootState } from '@/store'
import { E3tableC, statusObj } from '@/utils/tableData'
import classNames from 'classnames'
import dayjs from 'dayjs'
import { selectObj } from '@/utils/select'
import { E1inputKeyArr } from '../E1accident/data'
import { E1baseFormData } from '../E1accident'
import { E1InputKeyType } from '../E1accident/type'
import MyTable from '@/components/MyTable'
import Y1cathet from '@/pages/Y_goodsDetails/Y1cathet'
const { RangePicker } = DatePicker

function E3actuality() {
  const dispatch = useDispatch()
  const [formData, setFormData] = useState(E1baseFormData)
  const formDataRef = useRef(E1baseFormData)
  const formDataOldRef = useRef(E1baseFormData)

  useEffect(() => {
    formDataRef.current = formData
  }, [formData])

  // 点击搜索的 时间戳
  const [timeKey, setTimeKey] = useState(0)

  // 点击搜索
  const clickSearch = useCallback(() => {
    setFormData({ ...formData, pageNum: 1 })
    setTimeout(() => {
      setTimeKey(Date.now())
    }, 50)
  }, [formData])

  // 时间选择器改变

  const timeChange = useCallback(
    (date: any, dateString: any) => {
      let businessTimeStart = ''
      let businessTimeEnd = ''
      if (dateString[0] && dateString[1]) {
        businessTimeStart = dateString[0] + ' 00:00:00'
        businessTimeEnd = dateString[1] + ' 23:59:59'
      }
      setFormData({ ...formData, businessTimeStart, businessTimeEnd })
    },
    [formData]
  )

  const timeChange2 = useCallback(
    (date: any, dateString: any) => {
      let startTime = ''
      let endTime = ''
      if (dateString[0] && dateString[1]) {
        startTime = dateString[0] + ' 00:00:00'
        endTime = dateString[1] + ' 23:59:59'
      }
      setFormData({ ...formData, startTime, endTime })
    },
    [formData]
  )

  // 封装发送请求的函数
  const getListFu = useCallback(() => {
    formDataOldRef.current = { ...formDataRef.current }
    dispatch(E3_APIgetList(formDataRef.current))
  }, [dispatch])

  useEffect(() => {
    getListFu()
  }, [getListFu, timeKey])

  // 输入框的改变
  const txtChangeFu = useCallback(
    (txt: string, key: E1InputKeyType) => {
      setFormData({
        ...formData,
        [key]: txt
      })
    },
    [formData]
  )
  // 点击重置
  const resetSelectFu = useCallback(() => {
    setFormData(E1baseFormData)
    setTimeout(() => {
      setTimeKey(Date.now())
    }, 50)
  }, [])

  // 页码变化
  const paginationChange = useCallback(
    (pageNum: number, pageSize: number) => {
      setFormData({ ...formData, pageNum, pageSize })
      setTimeout(() => {
        setTimeKey(Date.now())
      }, 50)
    },
    [formData]
  )

  // 点击删除
  const delTableFu = useCallback(
    async (id: number) => {
      const res = await E3_APIdel(id)
      if (res.code === 0) {
        MessageFu.success('删除成功')
        getListFu()
      }
    },
    [getListFu]
  )

  // 点击各种操作按钮
  const tableBtnFu = useCallback((id: number, key: string) => {
    history.push(`/actuality_edit/${key}/${id}`)
  }, [])

  const tableLastBtn = useMemo(() => {
    return [
      {
        title: '操作',
        render: (item: FourTableType) => {
          let obj = btnFlagFu(item)
          return !Object.values(obj).some(Boolean) ? (
            '-'
          ) : (
            <>
              {obj['编辑'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '2')}>
                  编辑
                </Button>
              ) : null}

              {obj['审批'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '3')}>
                  审批
                </Button>
              ) : null}
              {obj['查看'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '4')}>
                  查看
                </Button>
              ) : null}

              {obj['删除'] ? (
                <MyPopconfirm txtK='删除' onConfirm={() => delTableFu(item.id)} />
              ) : null}
            </>
          )
        }
      }
    ]
  }, [delTableFu, tableBtnFu])

  // 打开侧边栏
  const [cathet, setCathet] = useState(0)

  const startBtn = useMemo(() => {
    return [
      {
        title: '藏品编号',
        render: (item: FourTableType) => {
          return (
            <span
              onClick={() => setCathet(Number(item.goodsIds))}
              className={classNames('D1GtNum', item.id === cathet ? 'D1GtNumAc' : '')}
            >
              {item.goodsNum || '（空）'}
            </span>
          )
        }
      }
    ]
  }, [cathet])

  // 从仓库拿数据
  const tableInfo = useSelector((state: RootState) => state.E3actuality.tableInfo)

  // 点击导出
  const deriveFu = useCallback(async () => {
    const res = await E3_APIgetList(
      {
        ...formDataOldRef.current,
        pageNum: 1,
        pageSize: 99999
      },
      true
    )

    if (res.code === 0) {
      if (res.data.records.length <= 0) return MessageFu.warning('当前搜索条件没有数据!')

      store.dispatch({
        type: 'layout/exInfo',
        payload: {
          name: '现状登记',
          show: true,
          arr: [
            { key: 'goodsNum', txt: '藏品编号' },
            { key: 'numName', txt: '编号类型' },
            { key: 'num', txt: '订单编号' },
            { key: 'date', txt: '登记日期' },
            { key: 'goodsName', txt: '藏品名称' },
            { key: 'sonUser', txt: '经手人' },
            { key: 'creatorName', txt: '发起人' },
            { key: 'createTime', txt: '发起日期' },
            { key: 'status', txt: '申请状态' }
          ],
          data: res.data.records.map((v: FourTableType) => ({
            ...v,
            status: statusObj[v.status as 1]
          }))
        }
      })
    }
  }, [])

  return (
    <div className={styles.E3actuality}>
      <div className='pageTitle'>现状登记</div>
      <div className='E3top'>
        <div className='E3topll'>
          {E1inputKeyArr.map(item => (
            <div key={item.name}>
              <span>{item.name}：</span>
              <Input
                placeholder={`请输入${item.name}`}
                maxLength={30}
                value={formData[item.key]}
                onChange={e => txtChangeFu(e.target.value, item.key)}
              />
            </div>
          ))}

          <div>
            <span>编号类型：</span>
            <Select
              allowClear={true}
              placeholder='全部'
              style={{ width: 150 }}
              value={formData.numName ? formData.numName : null}
              onChange={e => setFormData({ ...formData, numName: e })}
              options={selectObj['藏品编号类型']}
            />
          </div>
        </div>
        <div className='E3toprr'>
          <Button type='primary' onClick={deriveFu}>
            批量导出
          </Button>
          &emsp;
          <Button type='primary' onClick={() => history.push('/actuality_edit/1/null')}>
            新增
          </Button>
        </div>
      </div>

      <div className='E3top'>
        <div className='E3topll'>
          <div>
            <span>登记日期范围：</span>
            <RangePicker
              style={{ width: 234 }}
              value={
                formData.businessTimeStart
                  ? [dayjs(formData.businessTimeStart), dayjs(formData.businessTimeEnd)]
                  : null
              }
              onChange={timeChange}
            />
          </div>

          <div>
            <span>发起日期范围：</span>
            <RangePicker
              style={{ width: 234 }}
              value={
                formData.startTime ? [dayjs(formData.startTime), dayjs(formData.endTime)] : null
              }
              onChange={timeChange2}
            />
          </div>

          <div>
            <span>选择角色：</span>
            <Select
              allowClear={true}
              style={{ width: 150 }}
              placeholder='全部'
              options={selectObj['角色']}
              // fieldNames={{ value: 'id', label: 'roleName' }}
              value={formData.userType ? formData.userType : null}
              onChange={e => setFormData({ ...formData, userType: e })}
            />
          </div>

          <div>
            <span>申请状态：</span>
            <Select
              allowClear={true}
              placeholder='全部'
              style={{ width: 150 }}
              value={formData.status ? formData.status : null}
              onChange={e => setFormData({ ...formData, status: e })}
              options={selectObj['申请状态'].filter(v => v.label !== '待盘点')}
            />
          </div>
        </div>
        <div className='E3toprr'>
          <Button type='primary' onClick={clickSearch}>
            查询
          </Button>
          &emsp;<Button onClick={resetSelectFu}>重置</Button>
        </div>
      </div>
      {/* 表格 */}
      <MyTable
        emptyText={true}
        yHeight={610}
        list={tableInfo.list}
        columnsTemp={E3tableC}
        startBtn={startBtn}
        lastBtn={tableLastBtn}
        pageNum={formData.pageNum}
        pageSize={formData.pageSize}
        total={tableInfo.total}
        onChange={(pageNum, pageSize) => paginationChange(pageNum, pageSize)}
      />
      {/* 打开侧边栏 */}
      <Y1cathet sId={cathet} closeFu={() => setCathet(0)} />
    </div>
  )
}

const MemoE3actuality = React.memo(E3actuality)

export default MemoE3actuality
